# -*- coding: utf-8 -*-
"""
Category Topics vocabulary definition
"""

# from plone import api
from clms.downloadtool.utils import DATASET_FORMATS
from zope.interface import implementer
from zope.schema.interfaces import IVocabularyFactory
from zope.schema.vocabulary import SimpleTerm
from zope.schema.vocabulary import SimpleVocabulary


class VocabItem:
    """
    VocabItem class
    """

    def __init__(self, token, value):
        self.token = token
        self.value = value


@implementer(IVocabularyFactory)
class FullDatasetFormatsVocabulary:
    """
    FullDatasetFormats vocabulary class
    """

    def __call__(self, context):
        # Just an example list of content for our vocabulary,
        # this can be any static or dynamic data, a catalog result for example.
        items = [VocabItem(value, value) for value in DATASET_FORMATS]

        # create a list of SimpleTerm items:
        terms = []
        for item in items:
            terms.append(
                SimpleTerm(
                    value=item.token,
                    token=str(item.token),
                    title=item.value,
                )
            )
        # Create a SimpleVocabulary from the terms list and return it:
        return SimpleVocabulary(terms)


FullDatasetFormatsVocabularyFactory = FullDatasetFormatsVocabulary()
