# -*- coding: utf-8 -*-
"""
Topics vocabulary definition
"""

from zope.interface import implementer
from zope.schema.interfaces import IVocabularyFactory
from zope.schema.vocabulary import SimpleTerm, SimpleVocabulary


class VocabItem:
    """
    VocabItem class
    """

    def __init__(self, token, value):
        self.token = token
        self.value = value


@implementer(IVocabularyFactory)
class UseCaseSpatialCoverageVocabulary:
    """
    Topics vocabulary class
    """

    def __call__(self, context):
        # Just an example list of content for our vocabulary,
        # this can be any static or dynamic data, a catalog result for example.
        items = [
            VocabItem("AD", "Andorra"),
            VocabItem("AE", "United Arab Emirates"),
            VocabItem("AF", "Afghanistan"),
            VocabItem("AG", "Antigua and Barbuda"),
            VocabItem("AI", "Anguilla"),
            VocabItem("AL", "Albania"),
            VocabItem("AM", "Armenia"),
            VocabItem("AO", "Angola"),
            VocabItem("AR", "Argentina"),
            VocabItem("AS", "American Samoa"),
            VocabItem("AT", "Austria"),
            VocabItem("BW", "Botswana"),
            VocabItem("CG", "Congo"),
            VocabItem("CH", "Switzerland"),
            VocabItem("CI", "Côte D’Ivoire"),
            VocabItem("CK", "Cook Islands"),
            VocabItem("AQ", "Antarctica"),
            VocabItem("BY", "Belarus"),
            VocabItem("BZ", "Belize"),
            VocabItem("BJ", "Benin"),
            VocabItem("BN", "Brunei"),
            VocabItem("BO", "Bolivia"),
            VocabItem("BQ", "Bonaire, Sint Eustatius and Saba"),
            VocabItem("BT", "Bhutan"),
            VocabItem("BV", "Bouvet Island"),
            VocabItem("BR", "Brazil"),
            VocabItem("BS", "Bahamas"),
            VocabItem("CA", "Canada"),
            VocabItem("AU", "Australia"),
            VocabItem("AW", "Aruba"),
            VocabItem("AZ", "Azerbaijan"),
            VocabItem("BA", "Bosnia and Herzegovina"),
            VocabItem("BB", "Barbados"),
            VocabItem("BD", "Bangladesh"),
            VocabItem("BE", "Belgium"),
            VocabItem("BF", "Burkina Faso"),
            VocabItem("BG", "Bulgaria"),
            VocabItem("BH", "Bahrain"),
            VocabItem("BI", "Burundi"),
            VocabItem("CL", "Chile"),
            VocabItem("CD", "Democratic Republic of The Congo"),
            VocabItem("CF", "Central African Republic"),
            VocabItem("CN", "China"),
            VocabItem("DJ", "Djibouti"),
            VocabItem("DM", "Dominica"),
            VocabItem("DO", "Dominican Republic"),
            VocabItem("CO", "Colombia"),
            VocabItem("CR", "Costa Rica"),
            VocabItem("CU", "Cuba"),
            VocabItem("CV", "Cape Verde"),
            VocabItem("CW", "Curaçao"),
            VocabItem("CY", "Cyprus"),
            VocabItem("CZ", "Czechia"),
            VocabItem("FI", "Finland"),
            VocabItem("CM", "Cameroon"),
            VocabItem("DE", "Germany"),
            VocabItem("DZ", "Algeria"),
            VocabItem("DK", "Denmark"),
            VocabItem("ER", "Eritrea"),
            VocabItem("EL", "Greece"),
            VocabItem("ET", "Ethiopia"),
            VocabItem("FM", "Micronesia"),
            VocabItem("FO", "Faroes"),
            VocabItem("GA", "Gabon"),
            VocabItem("GD", "Grenada"),
            VocabItem("GE", "Georgia"),
            VocabItem("GG", "Guernsey"),
            VocabItem("GH", "Ghana"),
            VocabItem("GI", "Gibraltar"),
            VocabItem("FR", "France"),
            VocabItem("ES", "Spain"),
            VocabItem("FJ", "Fiji"),
            VocabItem("FK", "Falkland Islands"),
            VocabItem("EC", "Ecuador"),
            VocabItem("EE", "Estonia"),
            VocabItem("EG", "Egypt"),
            VocabItem("EH", "Western Sahara"),
            VocabItem("GL", "Greenland"),
            VocabItem("GM", "Gambia"),
            VocabItem("GN", "Guinea"),
            VocabItem("GQ", "Equatorial Guinea"),
            VocabItem("GS", "South Georgia and The South Sandwich Islands"),
            VocabItem("GT", "Guatemala"),
            VocabItem("GU", "Guam"),
            VocabItem("GW", "Guinea-Bissau"),
            VocabItem("HR", "Croatia"),
            VocabItem("HT", "Haiti"),
            VocabItem("HU", "Hungary"),
            VocabItem("GY", "Guyana"),
            VocabItem("HK", "Hong Kong"),
            VocabItem("HM", "Heard Island and Mcdonald Islands"),
            VocabItem("HN", "Honduras"),
            VocabItem("KH", "Cambodia"),
            VocabItem("KI", "Kiribati"),
            VocabItem("KM", "Comoros"),
            VocabItem("KN", "Saint Kitts and Nevis"),
            VocabItem("KP", "North Korea"),
            VocabItem("KW", "Kuwait"),
            VocabItem("KY", "Cayman Islands"),
            VocabItem("NP", "Nepal"),
            VocabItem("NR", "Nauru"),
            VocabItem("NU", "Niue"),
            VocabItem("IT", "Italy"),
            VocabItem("LC", "Saint Lucia"),
            VocabItem("LI", "Liechtenstein"),
            VocabItem("MR", "Mauritania"),
            VocabItem("KR", "South Korea"),
            VocabItem("LA", "Laos"),
            VocabItem("MS", "Montserrat"),
            VocabItem("JP", "Japan"),
            VocabItem("KG", "Kyrgyzstan"),
            VocabItem("ID", "Indonesia"),
            VocabItem("IE", "Ireland"),
            VocabItem("IL", "Israel"),
            VocabItem("IM", "Isle of Man"),
            VocabItem("IO", "British Indian Ocean Territory"),
            VocabItem("IN", "India"),
            VocabItem("IQ", "Iraq"),
            VocabItem("IS", "Iceland"),
            VocabItem("JE", "Jersey"),
            VocabItem("JM", "Jamaica"),
            VocabItem("JO", "Jordan"),
            VocabItem("IR", "Iran"),
            VocabItem("KE", "Kenya"),
            VocabItem("OM", "Oman"),
            VocabItem("LB", "Lebanon"),
            VocabItem("LS", "Lesotho"),
            VocabItem("LT", "Lithuania"),
            VocabItem("LU", "Luxembourg"),
            VocabItem("LV", "Latvia"),
            VocabItem("LY", "Libya"),
            VocabItem("MA", "Morocco"),
            VocabItem("MM", "Myanmar/Burma"),
            VocabItem("NO", "Norway"),
            VocabItem("PA", "Panama"),
            VocabItem("LK", "Sri Lanka"),
            VocabItem("LR", "Liberia"),
            VocabItem("ML", "Mali"),
            VocabItem("MN", "Mongolia"),
            VocabItem("MO", "Macau"),
            VocabItem("MP", "Northern Mariana Islands"),
            VocabItem("NE", "Niger"),
            VocabItem("MD", "Moldova"),
            VocabItem("ME", "Montenegro"),
            VocabItem("MG", "Madagascar"),
            VocabItem("MK", "North Macedonia"),
            VocabItem("MT", "Malta"),
            VocabItem("MU", "Mauritius"),
            VocabItem("KZ", "Kazakhstan"),
            VocabItem("MW", "Malawi"),
            VocabItem("MY", "Malaysia"),
            VocabItem("MZ", "Mozambique"),
            VocabItem("NA", "Namibia"),
            VocabItem("NC", "New Caledonia"),
            VocabItem("NG", "Nigeria"),
            VocabItem("NI", "Nicaragua"),
            VocabItem("NL", "Netherlands"),
            VocabItem("PG", "Papua New Guinea"),
            VocabItem("PT", "Portugal"),
            VocabItem("PW", "Palau"),
            VocabItem("PY", "Paraguay"),
            VocabItem("QA", "Qatar"),
            VocabItem("RO", "Romania"),
            VocabItem("NZ", "New Zealand"),
            VocabItem("PE", "Peru"),
            VocabItem("PF", "French Polynesia"),
            VocabItem("NF", "Norfolk Island"),
            VocabItem("MX", "Mexico"),
            VocabItem("PH", "Philippines"),
            VocabItem("PK", "Pakistan"),
            VocabItem("PL", "Poland"),
            VocabItem("PM", "Saint Pierre and Miquelon"),
            VocabItem("PN", "Pitcairn Islands"),
            VocabItem("PR", "Puerto Rico"),
            VocabItem("PS", "Palestine"),
            VocabItem("RS", "Serbia"),
            VocabItem("RU", "Russian Federation"),
            VocabItem("RW", "Rwanda"),
            VocabItem("SA", "Saudi Arabia"),
            VocabItem("TF", "French Southern and Antarctic Lands"),
            VocabItem("TG", "Togo"),
            VocabItem("TH", "Thailand"),
            VocabItem("TJ", "Tajikistan"),
            VocabItem("TL", "Timor-Leste"),
            VocabItem("SS", "South Sudan"),
            VocabItem("ST", "São Tomé and Príncipe"),
            VocabItem("SV", "El Salvador"),
            VocabItem("SY", "Syria"),
            VocabItem("SZ", "Eswatini"),
            VocabItem("TC", "Turks and Caicos Islands"),
            VocabItem("TD", "Chad"),
            VocabItem("SC", "Seychelles"),
            VocabItem("SB", "Solomon Islands"),
            VocabItem("TT", "Trinidad and Tobago"),
            VocabItem("TR", "Turkey"),
            VocabItem("TZ", "United Republic of Tanzania"),
            VocabItem("SD", "Sudan"),
            VocabItem("SE", "Sweden"),
            VocabItem("SG", "Singapore"),
            VocabItem("SH", "Saint Helena, Ascension and Tristan Da Cunha"),
            VocabItem("SI", "Slovenia"),
            VocabItem("SK", "Slovakia"),
            VocabItem("SL", "Sierra Leone"),
            VocabItem("SM", "San Marino"),
            VocabItem("SN", "Senegal"),
            VocabItem("TM", "Turkmenistan"),
            VocabItem("TN", "Tunisia"),
            VocabItem("TO", "Tonga"),
            VocabItem("SO", "Somalia"),
            VocabItem("SR", "Suriname"),
            VocabItem("SJ", "Svalbard and Jan Mayen"),
            VocabItem("XV", "Bir Tawil (Disputed Territory)"),
            VocabItem("YE", "Yemen"),
            VocabItem("ZA", "South Africa"),
            VocabItem("ZM", "Zambia"),
            VocabItem("ZW", "Zimbabwe"),
            VocabItem("UA", "Ukraine"),
            VocabItem("UG", "Uganda"),
            VocabItem("UK", "United Kingdom"),
            VocabItem("XH", "Jammu Kashmir"),
            VocabItem("XI", "Kuril Islands"),
            VocabItem("XO", "Bassas Da India"),
            VocabItem("XU", "Abyei"),
            VocabItem("VE", "Venezuela"),
            VocabItem("VG", "British Virgin Islands"),
            VocabItem("VI", "Us Virgin Islands"),
            VocabItem("VU", "Vanuatu"),
            VocabItem("VN", "Vietnam"),
            VocabItem("WS", "Samoa"),
            VocabItem("XC", "Aksai Chin"),
            VocabItem("XD", "Arunachal Pradesh"),
            VocabItem("XE", "China/India"),
            VocabItem("XF", "Hala'Ib Triangle"),
            VocabItem("XG", "Ilemi Triangle"),
            VocabItem("US", "United States"),
            VocabItem("UY", "Uruguay"),
            VocabItem("UZ", "Uzbekistan"),
            VocabItem("VA", "Vatican City"),
            VocabItem("VC", "Saint Vincent and The Grenadines"),
            VocabItem("KO", "Kosovo under UNSCR 1244/99*)"),
            VocabItem("EU", "European Union"),
            VocabItem("EU 27+UK", "European Union + United Kingdom"),
            VocabItem("EEA38", "EEA38 + United Kingdom"),
        ]

        # create a list of SimpleTerm items:
        terms = []
        for item in sorted(items, key=lambda x: x.value):
            terms.append(
                SimpleTerm(
                    value=item.token,
                    token=str(item.token),
                    title=item.value,
                )
            )
        # Create a SimpleVocabulary from the terms list and return it:
        return SimpleVocabulary(terms)


UseCaseSpatialCoverageVocabularyFactory = UseCaseSpatialCoverageVocabulary()
